<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJPSOAP_HotelInventoryDescription ArrayType
 * @subpackage Arrays
 */
class ArrayOfJPSOAP_HotelInventoryDescription extends AbstractStructArrayBase
{
    /**
     * The Description
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JPSOAP_HotelInventoryDescription[]
     */
    public $Description;
    /**
     * Constructor method for ArrayOfJPSOAP_HotelInventoryDescription
     * @uses ArrayOfJPSOAP_HotelInventoryDescription::setDescription()
     * @param \StructType\JPSOAP_HotelInventoryDescription[] $description
     */
    public function __construct(array $description = array())
    {
        $this
            ->setDescription($description);
    }
    /**
     * Get Description value
     * @return \StructType\JPSOAP_HotelInventoryDescription[]|null
     */
    public function getDescription()
    {
        return $this->Description;
    }
    /**
     * This method is responsible for validating the values passed to the setDescription method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDescription method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDescriptionForArrayConstraintsFromSetDescription(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJPSOAP_HotelInventoryDescriptionDescriptionItem) {
            // validation for constraint: itemType
            if (!$arrayOfJPSOAP_HotelInventoryDescriptionDescriptionItem instanceof \StructType\JPSOAP_HotelInventoryDescription) {
                $invalidValues[] = is_object($arrayOfJPSOAP_HotelInventoryDescriptionDescriptionItem) ? get_class($arrayOfJPSOAP_HotelInventoryDescriptionDescriptionItem) : sprintf('%s(%s)', gettype($arrayOfJPSOAP_HotelInventoryDescriptionDescriptionItem), var_export($arrayOfJPSOAP_HotelInventoryDescriptionDescriptionItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Description property can only contain items of type \StructType\JPSOAP_HotelInventoryDescription, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Description value
     * @throws \InvalidArgumentException
     * @param \StructType\JPSOAP_HotelInventoryDescription[] $description
     * @return \ArrayType\ArrayOfJPSOAP_HotelInventoryDescription
     */
    public function setDescription(array $description = array())
    {
        // validation for constraint: array
        if ('' !== ($descriptionArrayErrorMessage = self::validateDescriptionForArrayConstraintsFromSetDescription($description))) {
            throw new \InvalidArgumentException($descriptionArrayErrorMessage, __LINE__);
        }
        $this->Description = $description;
        return $this;
    }
    /**
     * Add item to Description value
     * @throws \InvalidArgumentException
     * @param \StructType\JPSOAP_HotelInventoryDescription $item
     * @return \ArrayType\ArrayOfJPSOAP_HotelInventoryDescription
     */
    public function addToDescription(\StructType\JPSOAP_HotelInventoryDescription $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JPSOAP_HotelInventoryDescription) {
            throw new \InvalidArgumentException(sprintf('The Description property can only contain items of type \StructType\JPSOAP_HotelInventoryDescription, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Description[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JPSOAP_HotelInventoryDescription|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JPSOAP_HotelInventoryDescription|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JPSOAP_HotelInventoryDescription|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JPSOAP_HotelInventoryDescription|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JPSOAP_HotelInventoryDescription|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Description
     */
    public function getAttributeName()
    {
        return 'Description';
    }
}
